#include "stdafx.h"
#include <windows.h>
#include <iostream>

using namespace std;

BOOL ReadRegString( HKEY hKey, LPCTSTR lpszValue, LPTSTR value, DWORD &len )
{

	BYTE* data = (BYTE*)value;

	DWORD dwType;

	LONG retValue = RegQueryValueEx(
		hKey,			
		lpszValue,		
		0,				
		&dwType,		
		data,			
		&len			
		);

	if( retValue == ERROR_MORE_DATA ||
		( retValue == ERROR_SUCCESS && data == NULL ) )
	{
		return FALSE;
	}
	else if( retValue == ERROR_SUCCESS && ( dwType == REG_SZ || dwType == REG_MULTI_SZ ) )
	{
		return TRUE;
	}
	
	return FALSE;
}

int _tmain(int argc, _TCHAR* argv[])
{
   SC_HANDLE myService, scm;
   LPCTSTR lpDependencies = TEXT("TBS\0\0");
   cout << "Installing TCSD Service...\n";
   // open a connection to the SCM
   scm = OpenSCManager(0, 0, SC_MANAGER_CREATE_SERVICE);
   if (!scm)
   {
      cout << "OpenSCManager fails! ";
	  cout << GetLastError();
   }
   cout << "Opened Service Control Manager...\n";

   	HKEY hKey = NULL;
	LONG retValue = RegOpenKeyEx ( HKEY_CURRENT_USER, TEXT("Software\\TrouSerS"),
								   NULL, KEY_QUERY_VALUE, &hKey );
	
	DWORD len = 1024;
	WCHAR pathStr[1024];
	ReadRegString( hKey, L"instdir", pathStr, len);

   // Install the new service
   myService = CreateService(
      scm, TEXT("tcsd"), // the internal service name used by the SCM
      TEXT("TCSD Service"),  // the external label seen in the Service Control applet
      SERVICE_ALL_ACCESS,		  // We want full access to control the service
      SERVICE_WIN32_OWN_PROCESS,  // The service is a single app and not a driver
      SERVICE_AUTO_START,		  // The service will be started by us manually
      SERVICE_ERROR_NORMAL,		  // If error during service start, don't misbehave.
      pathStr,
      0, 0, lpDependencies, 0, 0);
   if (!myService)
   {
	  cout << "CreateService fails! ";
	  cout << GetLastError();
   }
   else
   {
      cout << "Service successfully installed.\n";
   }
   // clean up
   CloseServiceHandle(myService);
   CloseServiceHandle(scm);
}



